#include "CollisionCreator.h"

CollisionBubble CollisionCreator::ModelToBubble(Model& model, int frame, unsigned int type) { //type 0 innerhalb, 1 mittelwert, 
	vec3_t median = {0,0,0};
	float radius;
	vec3_t* vertices = model.GetVertices();
	int num_vertices = model.GetNum_Vertices();
	int num_frames = model.GetNum_Frames();
	float scale = model.GetScale();

	if (frame > num_frames - 1)
		frame = 0;

	for (int i = 0; i < num_vertices; i++) {
		median[0] += vertices[i + frame * num_vertices][0];
		median[1] += vertices[i + frame * num_vertices][1];
		median[2] += vertices[i + frame * num_vertices][2];
	}

	median[0] /= num_vertices;
	median[1] /= num_vertices;
	median[2] /= num_vertices;
	

	switch (type) {
		case 0:
			radius = 100000;
			for (int i = 0; i < num_vertices; i++) {
				float tempr = sqrt(pow(median[0] - vertices[i + frame * num_vertices][0], 2) +
				pow(median[1] - vertices[i + frame * num_vertices][1], 2) +
				pow(median[2] - vertices[i + frame * num_vertices][2], 2));
				if (tempr < radius) radius = tempr;
			}
			break;
		case 1:
			radius = 0;
			for (int i = 0; i < num_vertices; i++) {
				float tempr = sqrt(pow(median[0] - vertices[i + frame * num_vertices][0], 2) +
				pow(median[1] - vertices[i + frame * num_vertices][1], 2) +
				pow(median[2] - vertices[i + frame * num_vertices][2], 2));
				radius += tempr;
			}
			radius /= num_vertices;
			break;
		case 2:
			radius = -100000;
			for (int i = 0; i < num_vertices; i++) {
				float tempr = sqrt(pow(median[0] - vertices[i + frame * num_vertices][0], 2) +
				pow(median[1] - vertices[i + frame * num_vertices][1], 2) +
				pow(median[2] - vertices[i + frame * num_vertices][2], 2));
				if (tempr > radius) radius = tempr;
			}
	}

	return CollisionBubble(Vector( median[1] * scale, median[2] * scale, median[0] * scale ), (float) radius * scale);
}

CollisionCuboid CollisionCreator::ModelToPlane(Model& model, int frame) {
	Vector planeVerts[4];
	
	float max_z = -100000;

	vec3_t* vertices = model.GetVertices();
	int num_vertices = model.GetNum_Vertices();
	int num_frames = model.GetNum_Frames();
	float scale = model.GetScale();

	if (frame > num_frames - 1)
		frame = 0;

	int oldvertindex[4] = {-1,-1,-1,-1};

	for (int j = 0; j < 4; j++) {
		int vertindex = -1;
		max_z = -100000;

		for (int i = 0; i < num_vertices; i++) {
			
			if (i != oldvertindex[0] &&
				i != oldvertindex[1] &&
				i != oldvertindex[2] &&
				i != oldvertindex[3] && max_z < vertices[i + frame * num_vertices][2]) {
				printf("F\n");
				max_z = vertices[i + frame * num_vertices][2];
				vertindex = i + frame * num_vertices;
			}
			printf("FALLERA!!!\n");
			printf("%f %f %f\n", vertices[i+ frame * num_vertices][1],vertices[i+ frame * num_vertices][2],vertices[i+ frame * num_vertices][0]);
		}
		oldvertindex[j] = vertindex;
		printf("%i / %i\n", num_vertices,vertindex);
		printf("%f %f %f\n", vertices[vertindex][1],vertices[vertindex][2],vertices[vertindex][0]);

		planeVerts[j] = Vector(vertices[vertindex][1], vertices[vertindex][2], vertices[vertindex][0]);
	}

	if ((planeVerts[0].x<planeVerts[1].x)!=(planeVerts[2].x<planeVerts[3].x) && planeVerts[0].x!=planeVerts[1].x && planeVerts[2].x!=planeVerts[3].x) {
		std::cout << "da nr 1\n";
		Vector temp = planeVerts[2];
		planeVerts[2] = planeVerts[3];
		planeVerts[3] = temp;
	}
	if ((planeVerts[0].z<planeVerts[1].z)!=(planeVerts[2].z<planeVerts[3].z) && planeVerts[0].z!=planeVerts[1].z && planeVerts[2].z!=planeVerts[3].z) {
		std::cout << "da nr 2\n" << (bool)(planeVerts[0].z<planeVerts[1].z) << "\n" << (bool)(planeVerts[2].z<planeVerts[3].z) << "\n";
		Vector temp = planeVerts[2];
		planeVerts[2] = planeVerts[3];
		planeVerts[3] = temp;
	}

	printf("%f %f %f\n", planeVerts[0].x,planeVerts[0].y,planeVerts[0].z);
	printf("%f %f %f\n", planeVerts[1].x,planeVerts[1].y,planeVerts[1].z);
	printf("%f %f %f\n", planeVerts[2].x,planeVerts[2].y,planeVerts[2].z);
	printf("%f %f %f\n", planeVerts[3].x,planeVerts[3].y,planeVerts[3].z);
	
	Vector vec1 = planeVerts[1]-planeVerts[0];
	Vector vec2 = planeVerts[2]-planeVerts[0];
	Vector vec3 = Vector(0.0, -1.0, 0.0);
	vec1.Normalise();
	vec2.Normalise();
	vec3.Normalise();

	printf("normz: %f %f\n", vec1.z, vec2.z);
	printf("normx: %f %f\n", vec1.x, vec2.x);
	printf("acos: %f %f\n", acos(vec1.z), acos(vec2.z));

	float cos1 = (vec1.x<0)?(2*PI-acos(vec1.z)):acos(vec1.z);
	float cos2 = (vec2.x<0)?(2*PI-acos(vec2.z)):acos(vec2.z);
	printf("COS: %f %f\n", cos1, cos2);
	//cos1 += acos(vec1.z);
	//cos2 += acos(vec2.z);
	
	printf("COS: %f %f\n", cos1, cos2);

	//beide vektoren von oben entlang -y achse ansehen... beide winkel ausrechnen und voneinander abziehen

	Vector par1 = Vector();	
	Vector par2 = Vector();
	Vector par3 = Vector();

	float orientation = cos1-cos2;

	if (orientation < 0 && orientation > -PI || orientation < 2*PI && orientation > PI) {
		par1 = vec2.CrossProduct(vec1);
		par2 = vec1.CrossProduct(vec3);
		par3 = vec3.CrossProduct(vec2);
	} else if (orientation > 0 && orientation < PI || orientation > -2*PI && orientation < -PI) {
		par1 = vec1.CrossProduct(vec2);
		par2 = vec2.CrossProduct(vec3);
		par3 = vec3.CrossProduct(vec1);
	}

	par1.Normalise();
	par2.Normalise();
	par3.Normalise();
	

	return CollisionCuboid(planeVerts[0]*scale, (planeVerts[3]*scale)-(Vector(0.0,20.0,0.0)*scale), par1,
		par2, par3);
}

CollisionCuboid CollisionCreator::ModelToCuboid(Model& model, int frame) {
	float max_x = -100000;
	float min_x =  100000;
	float max_y = -100000;
	float min_y =  100000;
	float max_z = -100000;
	float min_z =  100000;

	vec3_t* vertices = model.GetVertices();
	int num_vertices = model.GetNum_Vertices();
	int num_frames = model.GetNum_Frames();
	float scale = model.GetScale();

	if (frame > num_frames - 1)
		frame = 0;

	for (int i = 0; i < num_vertices; i++) {
		if (max_x < vertices[i + frame * num_vertices][1]) {
			max_x = vertices[i + frame * num_vertices][1];
		}
		if (min_x > vertices[i + frame * num_vertices][1]) {
			min_x = vertices[i + frame * num_vertices][1];
		}
		if (max_y < vertices[i + frame * num_vertices][2]) {
			max_y = vertices[i + frame * num_vertices][2];
		}
		if (min_y > vertices[i + frame * num_vertices][2]) {
			min_y = vertices[i + frame * num_vertices][2];
		}
		if (max_z < vertices[i + frame * num_vertices][0]) {
			max_z = vertices[i + frame * num_vertices][0];
		}
		if (min_z > vertices[i + frame * num_vertices][0]) {
			min_z = vertices[i + frame * num_vertices][0];
		}
	}

	//printf("max/mins%f\n%f\n%f\n%f\n%f\n%f\n", max_x, min_x, max_y, min_y, max_z, min_z);

	Vector A = Vector(max_x * scale,max_y * scale,max_z * scale);
	Vector G = Vector(min_x * scale,min_y * scale,min_z * scale);
	Vector X = Vector(((min_x-max_x>0)?1.0f:-1.0f), 0.0f, 0.0f);
	Vector Y = Vector(0.0f, ((min_y-max_y>0)?1.0f:-1.0f), 0.0f);
	Vector Z = Vector(0.0f, 0.0f, ((min_z-max_z>0)?1.0f:-1.0f));
	//printf("richtungen:\n%f\n%f\n%f\n",X.x, Y.y, Z.z);

	return CollisionCuboid(A,G,X,Y,Z);
}

CollisionCuboid CollisionCreator::ModelToRotatedCuboid(Model& model, int frame) {
	vec3_t max_x = {-100000,0,0};
	vec3_t min_x = { 100000,0,0};
	vec3_t max_y = {0,-100000,0};
	vec3_t min_y = {0, 100000,0};
	vec3_t max_z = {0,0,-100000};
	vec3_t min_z = {0,0, 100000};

	vec3_t* vertices = model.GetVertices();
	int num_vertices = model.GetNum_Vertices();
	int num_frames = model.GetNum_Frames();
	float scale = model.GetScale();

	if (frame > num_frames - 1)
		frame = 0;

	for (int i = 0; i < num_vertices; i++) {
		if (max_x[0] < vertices[i + frame * num_vertices][0]) {
			max_x[0] = vertices[i + frame * num_vertices][0];
			max_x[1] = vertices[i + frame * num_vertices][1];
			max_x[2] = vertices[i + frame * num_vertices][2];
		}
		if (min_x[0] > vertices[i + frame * num_vertices][0]) {
			min_x[0] = vertices[i + frame * num_vertices][0];
			min_x[1] = vertices[i + frame * num_vertices][1];
			min_x[2] = vertices[i + frame * num_vertices][2];
		}
		if (max_y[1] < vertices[i + frame * num_vertices][1]) {
			max_y[0] = vertices[i + frame * num_vertices][0];
			max_y[1] = vertices[i + frame * num_vertices][1];
			max_y[2] = vertices[i + frame * num_vertices][2];
		}
		if (min_y[1] > vertices[i + frame * num_vertices][1]) {
			min_y[0] = vertices[i + frame * num_vertices][0];
			min_y[1] = vertices[i + frame * num_vertices][1];
			min_y[2] = vertices[i + frame * num_vertices][2];
		}
		if (max_z[2] < vertices[i + frame * num_vertices][2]) {
			max_z[0]= vertices[i + frame * num_vertices][0];
			max_z[1]= vertices[i + frame * num_vertices][1];
			max_z[2]= vertices[i + frame * num_vertices][2];
		}
		if (min_z[2] > vertices[i + frame * num_vertices][2]) {
			min_z[0] = vertices[i + frame * num_vertices][0];
			min_z[1] = vertices[i + frame * num_vertices][1];
			min_z[2] = vertices[i + frame * num_vertices][2];
		}
	}

	Vector y1 = Vector(max_y[0]-max_x[0], max_y[1]-max_x[1], max_y[2]-max_x[2]);
	Vector y2 = Vector(min_y[0]-max_x[0], min_y[1]-max_x[1], min_y[2]-max_x[2]);
	Vector z1 = Vector(max_z[0]-max_x[0], max_z[1]-max_x[1], max_z[2]-max_x[2]);
	Vector z2 = Vector(min_z[0]-max_x[0], min_z[1]-max_x[1], min_z[2]-max_x[2]);
	Vector x  = Vector(min_x[0]-max_x[0], min_x[1]-max_x[1], min_x[2]-max_x[2]);

	y1.Normalise();
	y2.Normalise();
	z1.Normalise();
	z2.Normalise();
	x.Normalise();

	float y1z1 = y1.DotProduct(z1);
	float y2z1 = y2.DotProduct(z1);
	float y1z2 = y1.DotProduct(z2);
	float y2z2 = y2.DotProduct(z2);
	
	if (y1z1 < 0) y1z1 = y1z1 * -1;
	if (y2z1 < 0) y2z1 = y2z1 * -1;
	if (y1z2 < 0) y1z2 = y1z2 * -1;
	if (y2z2 < 0) y2z2 = y2z2 * -1;

	float tempdot = min( min( y1z1, y2z1 ), min( y1z2, y2z2 ) );
	
	Vector vec1 = Vector();
	Vector vec2 = Vector();
	Vector vec3 = Vector();

	if (y1z1 == tempdot) {
		vec1 = y1;
		vec2 = z1;
		vec3 = y1.CrossProduct(z1);
		if (x.DotProduct(y1.CrossProduct(z1)) < 0)
			vec3 = vec3 * -1;			
	}
	if (y2z1 == tempdot) {
		vec1 = y2;
		vec2 = z1;
		vec3 = y2.CrossProduct(z1);
		if (x.DotProduct(y2.CrossProduct(z1)) < 0)
			vec3 = vec3 * -1;
	}
	if (y1z2 == tempdot) {
		vec1 = y1;
		vec2 = z2;
		vec3 = y1.CrossProduct(z2);
		if (x.DotProduct(y1.CrossProduct(z2)) < 0)
			vec3 = vec3 * -1;
	}
	else {
		vec1 = y2;
		vec2 = z2;
		vec3 = y2.CrossProduct(z2);
		if (x.DotProduct(y2.CrossProduct(z2)) < 0)
			vec3 = vec3 * -1;	
	}

	//printf("creator:\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n%f\n", max_x[0], max_x[1], max_x[2], min_x[0], min_x[1], min_x[2], vec1.x, vec1.y, vec1.z, vec2.x, vec2.y, vec2.z, vec3.x, vec3.y, vec3.z);

	return CollisionCuboid(Vector(max_x[0], max_x[1], max_x[2]), Vector(min_x[0], min_x[1], min_x[2]), vec1, vec2, vec3);
}

CollisionCreator::CollisionCreator() {

}

CollisionCreator::~CollisionCreator() {

}