#include "programme.h"


int texcount = 0;
int bubblecount = 0;

bool loadTexture(char *name) {
	Bitmap *image; 

	image=new Bitmap();

	if(image==NULL) {
		return false;
	}

	if (image->loadBMP(name)) {
		glGenTextures(1, &texture[texcount]); 

		glBindTexture(GL_TEXTURE_2D, texture[texcount]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		//glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
		//glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
		//cout << image->width << "*" << image->height << " " << image->data << endl;
		//glTexImage2D(GL_TEXTURE_2D, 0, 3, image->width, image->height, 0, 
		//			GL_RGB, GL_UNSIGNED_BYTE, image->data);
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, image->width, image->height,
			GL_RGB, GL_UNSIGNED_BYTE, image->data);

		texcount++;
	}
	else {
		return false;
	}

	if (image) {
		delete image;
	}

	return true;
}

GLvoid BuildFont(GLvoid)				// Build Our Bitmap Font
{
	HFONT	font;						// Windows Font ID
	HFONT	oldfont;					// Used For Good House Keeping

    base = glGenLists(96); 				// Storage For 96 Characters ( NEW )

	font = CreateFont( -12, 			// Height Of Font ( NEW )
	0, 									// Width Of Font
	0, 									// Angle Of Escapement
	0, 									// Orientation Angle
	FW_NORMAL, 							// Font Weight
	FALSE, 								// Italic
	FALSE, 								// Underline
	FALSE, 								// Strikeout
	ANSI_CHARSET, 						// Character Set Identifier
	OUT_TT_PRECIS, 						// Output Precision
	CLIP_DEFAULT_PRECIS, 				// Clipping Precision
	ANTIALIASED_QUALITY, 				// Output Quality
	FF_DONTCARE|DEFAULT_PITCH, 			// Family And Pitch
	"Courier New"); 					// Font Name

	oldfont = (HFONT)SelectObject(hDC, font); 	
	// Selects The Font We Want

	wglUseFontBitmaps(hDC, 32, 96, base); 		
	// Builds 96 Characters Starting At Character 32

	SelectObject(hDC, oldfont); 	// Selects The Font We Want
	DeleteObject(font); 			// Delete The Font
}

GLvoid glPrint(const char *fmt, ...) // Custom GL "Print" Routine
{
	char text[256]; 				// Holds Our String
	va_list ap; 					// Pointer To List Of Arguments

	if (fmt == NULL) 				// If There's No Text
		return; 					// Do Nothing

	va_start(ap, fmt); 				// Parses The String For Variables
	vsprintf(text, fmt, ap); 		// And Converts Symbols To Actual Numbers
	va_end(ap); 					// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT); 		// Pushes The Display List Bits ( NEW )
	glListBase(base - 32); 			// Sets The Base Character to 32 ( NEW )

	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text); // Draws The Display List    Text ( NEW )
	glPopAttrib(); // Pops The Display List Bits ( NEW )
}


int main(int argc, char** argv) {	
	//Initialize glut
	glutInit(&argc, argv);
	
	////Double refresh buffer and RGB color mode selected (default)
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	////Displays the window in the top left corner of the screen
	glutInitWindowPosition(WIN_X, WIN_Y);
	////Sets the initial size of the window
	glutInitWindowSize(WIN_WIDTH, WIN_HEIGHT);
	//Create window with the parameter string as title
	glutCreateWindow(TNS_WINDOWTITLE);

	hWindow = FindWindowA(0, TNS_WINDOWTITLE);
	if (!hWindow) return 1;

//	glutGameModeString("800x600:32@60");
//bool a = false;
//	if (a=glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) 
//		glutEnterGameMode();
//	else {
//		printf("The select mode is not available\n");
//		exit(1);	
//	}

	glutFullScreen();

	hDC=GetDC(hWindow);

	//Initialize objects
	InitGL();

	if (InitScene()) {
		glutDisplayFunc(Render);
		glutMotionFunc(CamMovement);
		glutMouseFunc(MouseClickFunc);
		glutPassiveMotionFunc(CamMovement);
		glutIgnoreKeyRepeat(true);
		glutKeyboardFunc(KeyboardHandler);
		glutKeyboardUpFunc(KeyboardUpHandler);
		glutSpecialFunc(KeyboardSpecialHandler);
		glutTimerFunc(TNS_REFRESHRATE, _Timer, 0);
		glutMainLoop();
	
	} else MessageBoxA(0, "Failed to load model.", TNS_WINDOWTITLE, MB_ICONHAND);
	UnloadScene();
	//glutLeaveGameMode();
	return 0;

}

void _Timer(int value) {
	Update();
	
	glutPostRedisplay();
	glutTimerFunc(TNS_REFRESHRATE, _Timer, 0);
}

void MouseClickFunc(int button, int state, int x, int y) {
	 objectattack = (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN);
}

void KeyboardSpecialHandler(int key, int x, int y) {
	//key = tolower(key);
	switch (key) {
		case GLUT_KEY_F2:
			showframerate=!showframerate;
			break;
		case GLUT_KEY_F3:
			wireframe=!wireframe;
			wireframetimer = 30;
			break;
		case GLUT_KEY_F8:
			frustum = !frustum;
			frustumtimer = 30;
			break;
	}
}

// Keyboard Down Handler
void KeyboardHandler(unsigned char key, int x, int y) {
	key = tolower(key);
	switch (key) {
		case 'w':
			if(freecam) cameraforward = true;
			else objectforward = true;
			break;
		case 'a':
			if(freecam) cameraleft = true;
			else objectleft = true;
			break;
		case 's':
			if(freecam) cameraback = true;
			else objectback = true;
			break;
		case 'd':
			if(freecam) cameraright = true;
			else objectright = true;
			break;
		case 'e':
			cameraup = true;
			break;
		case 'u':
			objectdie = true;
			break;
		case 'i':
			objecthit = true;
			break;
		case 'q':
			cameradown = true;
			break;
		case 'g':
			coordinates = !coordinates;
			break;
		case 'p':
			baer.LoadMD2("animated\\thebadguy.md2");
			baer.LoadTex("used\\enemy1.bmp");
			break;
		case 'l':
			baer.LoadMD2("animated\\teddy.md2");
			baer.LoadTex("used\\teddytextur.bmp");
			break;
		case 'c':
			freecam = !freecam;
			if (!freecam) {
				cam.SetCam(baer.GetPos()+baer.GetUp()*8-baer.GetView()*40, baer.GetView(), baer.GetUp(), baer.GetRight());
				cam.RotateX(-20.0f);
			}
			break;
		case VK_SPACE:
			objectjump = true;
			break;
		case VK_ESCAPE:
			CloseWindow(hWindow);
	}
}

//Keyboard Up Handler
void KeyboardUpHandler(unsigned char key, int x, int y) {
	key = tolower(key);

	switch (key) {
		case 'w':
			if(freecam) cameraforward = false;
			else objectforward = false;
			break;
		case 'a':
			if(freecam) cameraleft = false;
			else objectleft = false;
			break;
		case 's':
			if(freecam) cameraback = false;
			else objectback = false;
			break;
		case 'd':
			if(freecam) cameraright = false;
			else objectright = false;
			break;
		case 'e':
			cameraup = false;
			break;
		case 'q':
			cameradown = false;
			break;
		case 'u':
			objectdie = false;
			break;
		case 'i':
			objecthit = false;
			break;
		//case 'u':
		//	objectforward = false;
		//	break;
		//case 'j':;
		//	objectback = false;
		//	break;
		//case 'h':;
		//	objectleft = false;
		//	break;
		//case 'k':;
		//	objectright = false;
		//	break;
		//case 'i':;
		//	objectup = false;
		//	break;
		//case 'z':;
		//	objectdown = false;
		//	break;
		case VK_SPACE:;
			objectjump = false;
	}
}

//Camera Calculation
void CamMovement(GLint xMouse, GLint yMouse) {
		Vector rel = Vector();
	
		if (lastmousex != 0.0f && lastmousey != 0.0f) {
			rel.x = (lastmousex - xMouse);
			rel.y = (lastmousey - yMouse);
		}
		
		if (abs(rel.x) > 300.0f) rel.x = 0.0f;
		if (abs(rel.y) > 100.0f) rel.y = 0.0f;
		lastmousex = xMouse;
		lastmousey = yMouse;

		if (freecam) {
			cam.RotateX(rel.y/4);
			cam.RotateVerticalAxis(rel.x/2);
		} else {
			baer.RotateY(rel.x/2);
			//cam.SetCam(baer.GetPos()-baer.GetView()*40+baer.GetUp()*10, baer.GetView(), baer.GetUp(), baer.GetRight());
			cam.RotateX(rel.y/4); //langsamere bewegung
			cam.RotateVerticalAxis(rel.x/2);
			cam.SetCam(baer.GetPos()+baer.GetUp()*8-cam.GetView()*40, cam.GetView(), baer.GetRight().CrossProduct(cam.GetView()), baer.GetRight());
			//cam.RotateX(camhorizontalangle);
			//cam.SetCam(baer.GetPos()-cam.GetView()*40, cam.GetView(), baer.GetRight().CrossProduct(cam.GetView()), baer.GetRight());
		}
		POINT mouseposition;
		if(GetCursorPos(&mouseposition)) {
		if (abs(xMouse-WIN_WIDTH/2)>400)
			SetCursorPos(WIN_WIDTH/2,mouseposition.y);
		if (abs(yMouse-WIN_HEIGHT/2)>200)
			SetCursorPos(mouseposition.x,WIN_HEIGHT/2);
		}
}

CollisionBubble ziel;
CollisionBubble keyy;

int doornumber = -1;
bool doorvisible = true;

int InitScene() {	

	QueryPerformanceFrequency(&frequency);
	QueryPerformanceCounter(&time);
	//modelcollection = (Model*) malloc(sizeof(Model)*MAXMODELCOUNT);
	//modelcollection[0] = Model();
	//modelcount++;

	level1 = Level();
	level1.LoadLevel("level1.tns");

	ShowCursor(false);
	coll = CollisionCollection();

	//glEnable(GL_LIGHT0);
	//glEnable(GL_LIGHT1);

	cam.SetCam(baer.GetPos()+baer.GetUp()*8-baer.GetView()*40, baer.GetView(), baer.GetUp(), baer.GetRight());
	cam.RotateX(-20.0f);

	//glGenTextures(20, &texture[0]); 

	//loadTexture("carp.bmp");		//0
	//loadTexture("grass.bmp");		//1
	//loadTexture("kiste.bmp");		//2
	//loadTexture("gelb.bmp");		//3
	//loadTexture("sky.bmp");			//4
	//loadTexture("darkgrass.bmp");	//5
	//loadTexture("schweinchenrosa.bmp"); //6
	//loadTexture("wand64.bmp"); //7

	int i;

	//coll.insert(CollisionBubble(Vector(-27.5f, 9.0f, -47.5f), 9.0f));
	//coll.insert(CollisionBubble(Vector(-27.5f, 27.0f, -7.5f), 9.0f));
	coll.insert(CollisionCuboid(Vector(-40.0f, 0.0f, -50.0f ), Vector(-15.0f, 18.0f, -45.0f), Vector(2*sqrt(13.0f)/13.0f, 0.0f, 3*sqrt(13.0f)/13.0f), Vector(3*sqrt(13.0f)/13.0f, 0.0f, -2*sqrt(13.0f)/13), Vector(0.0f,1.0f,0.0f) ));
	coll.insert(CollisionCuboid(Vector(-40.0f, 18.0f,-10.0f ), Vector(-15.0f, 36.0f, -5.0f), Vector(2*sqrt(13.0f)/13.0f, 0.0f, 3*sqrt(13.0f)/13.0f), Vector(3*sqrt(13.0f)/13.0f, 0.0f, -2*sqrt(13.0f)/13), Vector(0.0f,1.0f,0.0f) ));
	i=coll.insert(CollisionCuboid(Vector(-10.0f,-15.0f,-17.5f ), Vector( 10.0f, 15.0f, 17.5f ),Vector(1.0f,0.0f,0.0f),Vector(0.0f,1.0f,0.0f), Vector(0.0f,0.0f,1.0f)));
	//std::cout << i << "trans" << std::endl;
	coll.GetCube(i)->Translate( 50.0f, 15.0f, 0.0f );
	i=coll.insert(CollisionCuboid(Vector(-9.0f,-9.0f,-9.0f ), Vector( 9.0f, 9.0f, 9.0f ),Vector(1.0f,0.0f,0.0f),Vector(0.0f,1.0f,0.0f), Vector(0.0f,0.0f,1.0f)));
	//std::cout << i << "trans" << std::endl;
	coll.GetCube(i)->Translate( 30.0f, 9.0f, 0.0f );
	i=coll.insert(CollisionCuboid(Vector(-9.0f,-9.0f,-9.0f ), Vector( 9.0f, 9.0f, 9.0f ),Vector(1.0f,0.0f,0.0f),Vector(0.0f,1.0f,0.0f), Vector(0.0f,0.0f,1.0f)));
	coll.GetCube(i)->Translate( 10.0f, 27.0f, 0.0f );
	i=coll.insert(CollisionCuboid(Vector(-9.0f,-9.0f,-9.0f ), Vector( 9.0f, 9.0f, 9.0f ),Vector(1.0f,0.0f,0.0f),Vector(0.0f,1.0f,0.0f), Vector(0.0f,0.0f,1.0f)));
	coll.GetCube(i)->Translate(-30.0f, 45.0f, 20.0f );;

	//coll.insert(CollisionCuboid(Vector(-310.0f,40.0f,90.0f ), Vector(-290.0f, 60.0f, 110.0f ),Vector(1.0f,0.0f,0.0f),Vector(0.0f,1.0f,0.0f), Vector(0.0f,0.0f,1.0f)));

	coll.insert(CollisionBubble(Vector(-20.0f,-20.0f,-20.0f), 25.0f));
	//coll.insert(CollisionBubble(Vector(10.0,-10.0f,8.0f), 17.0f)); //Huegel!! JIPPIE =)!
		




	
	creator = CollisionCreator();

	//CollisionBubble bub1 = CollisionBubble();
	//bub1 = creator.ModelToBubble(ogros, 0, 2);
	//bub1.Translate(0.0,10.0,-100.0);
	//coll.insert(bub1);

	door.LoadTex("used\\doordouble.bmp");
	door.LoadMD2("teddy\'s world\\Towerdoor.md2");
	door.ScaleModel(0.2);

	key.LoadTex("used\\Gelb.bmp");
	key.LoadMD2("teddy\'s world\\key.md2");
	key.ScaleModel(0.2);
	key.SetAnim(STAND);

	starr.LoadTex("used\\Gelb.bmp");
	starr.LoadMD2("teddy\'s world\\star.md2");
	starr.ScaleModel(0.2);
	starr.SetAnim(STAND);

	baer.LoadTex("used\\teddytextur.bmp");
	baer.LoadMD2("animated\\teddy.md2");
	baer.SetAnim(STAND);
	baer.ScaleModel(0.2);

	ogros.LoadMD2("animated\\thebadguy.md2");
	ogros.LoadTex("used\\enemy1.bmp");
	ogros.ScaleModel(0.2);
	ogros.SetModel(Vector(0,0,100), Vector(0,0,-1), Vector(0,1,0), Vector(1,0,0));
	ogros.SetAnim(RUN);

	star.LoadTex("used\\Sky.bmp");
	star.LoadMD2("teddy\'s world\\sky.md2");

	doornumber = level1.GetCollision()->insert(creator.ModelToCuboid(door,0));

	ziel = creator.ModelToBubble(starr,0,2);
	keyy = creator.ModelToBubble(key,0,2);

	return (true);
}

void UnloadScene() {
	glDeleteLists(base, 96); 		// Delete All 96 Characters ( NEW )
	//free(modelcollection);
}


void InitGL() {
	glMatrixMode(GL_PROJECTION);						//Set projection parameters
	glLoadIdentity();
	gluPerspective((GLdouble) 45.0f, (GLdouble) WIN_WIDTH/WIN_HEIGHT, (GLdouble) 1.0f, (GLdouble) 500.0f);

	glShadeModel(GL_FLAT);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_TEXTURE_2D);							// Enable Smooth Shading
	glClearColor(0.1f, 0.1f, 0.1f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	//glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations	

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	BuildFont(); // Build The Font (NEW)
	
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
}

float jumpvar = 0.0f;
boolean stop = false;
boolean ontop = false;
float dist = 0.0;
float dropvar = 0.0f;
int counter = 0;

void Update() {
	baer.Update();
	star.Update();

	grass.Update();

	if (objectdie && baer.GetAnimType() == STAND)
		baer.SetAnim(DIE);
	if (objecthit && baer.GetAnimType() == STAND)
		baer.SetAnim(BEHIT);
	if (objectattack && baer.GetAnimType() != ATTACK)
		baer.SetAnim(ATTACK);

	float frameratefactor = OPT_FRAMERATE/framerate;

	if(!objectforward && !objectback && !objectleft && !objectright && !objectjump &&
	    !objectattack && !objectdie && !objecthit && baer.GetAnimType()!=STAND)
		baer.SetAnim(STAND);

	//glutPostRedisplay();
	if(cameraforward) cam.MoveFwd(1.0f*frameratefactor);
	if(cameraleft) cam.MoveLeft(1.0f*frameratefactor);
	if(cameraback) cam.MoveBack(1.0f*frameratefactor);
	if(cameraright) cam.MoveRight(1.0f*frameratefactor);
	if(cameraup) cam.MoveUp(1.0f*frameratefactor);
	if(cameradown) cam.MoveDown(1.0f*frameratefactor);
	if(objectright) {
		if (baer.GetAnimType()== STAND)
			baer.SetAnim(WALKSIDE);
		baer.MoveRight(1.0f*frameratefactor);
		if (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
			level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)) {
			baer.MoveLeft(0.5f*frameratefactor);
			int i;
			for (i=0; i<5 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
				baer.MoveUp(0.1f*frameratefactor);
			if (i==5) {
				baer.MoveDown(0.5f*frameratefactor);
				for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
					baer.MoveFwd(0.1f*frameratefactor);
				if (i==10) {
					baer.MoveBack(1.0f*frameratefactor);
					for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
						baer.MoveBack(0.1f*frameratefactor);
					if (i==10) {
						baer.MoveFwd(1.0f*frameratefactor);
						baer.MoveLeft(0.5f*frameratefactor);
					}
				}
			}
		}
	}
	if(objectleft) {
		if (baer.GetAnimType()== STAND)
			baer.SetAnim(WALKSIDE);
		baer.MoveLeft(1.0f*frameratefactor);
		if (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
			level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f))
			baer.MoveRight(0.5f*frameratefactor);
			int i;
			for (i=0; i<5 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
				baer.MoveUp(0.1f*frameratefactor);
			if (i==5) {
				baer.MoveDown(0.5f*frameratefactor);
				for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
					baer.MoveFwd(0.1f*frameratefactor);
				if (i==10) {
					baer.MoveBack(1.0f*frameratefactor);
					for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
						baer.MoveBack(0.1f*frameratefactor);
					if (i==10) {
						baer.MoveFwd(1.0f*frameratefactor);
						baer.MoveRight(0.5f*frameratefactor);
					}
				}
			}
	}
	if(objectforward) {
		if (baer.GetAnimType()!=RUN && baer.GetAnimType() != ATTACK)
			baer.SetAnim(RUN);
		baer.MoveFwd(1.0f*frameratefactor);
		if (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
			level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)) {
			baer.MoveBack(0.5f*frameratefactor);
			int i;
			for (i=0; i<5 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
				baer.MoveUp(0.1f*frameratefactor);
			if (i==5) {
				baer.MoveDown(0.5f*frameratefactor);
				for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
					baer.MoveRight(0.1f*frameratefactor);
				if (i==10) {
					baer.MoveLeft(1.0f*frameratefactor);
					for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
						baer.MoveLeft(0.1f*frameratefactor);
					if (i==10) {
						baer.MoveRight(1.0f*frameratefactor);
						baer.MoveBack(0.5f*frameratefactor);
					}
				}
			}
		}
	}
	if(objectback) {
		if (baer.GetAnimType()!=RUN && baer.GetAnimType() != ATTACK)
			baer.SetAnim(RUN);
		baer.MoveBack(1.0f*frameratefactor);
		if (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
			level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)) {
			baer.MoveFwd(0.5f*frameratefactor);
			int i;
			for (i=0; i<5 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
				baer.MoveUp(0.1f*frameratefactor);
			if (i==5) {
				baer.MoveDown(0.5f*frameratefactor);
				for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
					baer.MoveRight(0.1f*frameratefactor);
				if (i==10) {
					baer.MoveLeft(1.0f*frameratefactor);
					for (i=0; i<10 && (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
								level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)); i++)
						baer.MoveLeft(0.1f*frameratefactor);
					if (i==10) {
						baer.MoveRight(1.0f*frameratefactor);
						baer.MoveFwd(0.5f*frameratefactor);
					}
				}
			}
		}
	}
	if((objectjump || jumpvar>0) && dropvar <= 5.0f ) { //jump
		if (baer.GetAnimType()!=JUMP && baer.GetAnimType() != ATTACK)
			baer.SetAnim(JUMP);
		dropvar=0.0f;
		baer.MoveUp(3*sin(PIdiv180*(jumpvar+90))*frameratefactor);
		if (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
			level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)) {
			baer.MoveDown(3*sin(PIdiv180*(jumpvar+90))*frameratefactor);
			jumpvar=0.0f;
		}
		else jumpvar+=10*frameratefactor;
		if (jumpvar>90) jumpvar = 0;
	}
	if(jumpvar==0) { //drop
		if (baer.GetPos().y < 0.0f) {
			dropvar = 0.0;
			baer.MoveUp(-baer.GetPos().y);
		} else if (baer.GetPos().y > 0.0f) {
			baer.MoveDown(-3*cos(PIdiv180*(dropvar+90))*frameratefactor);
			if (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
				level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f)) {
				baer.MoveUp(-3*cos(PIdiv180*(dropvar+90))*frameratefactor);
				baer.MoveDown(-3*cos(PIdiv180*(100))*frameratefactor);
				if (level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) || // Aufgrund von Dropverzoegerung
					level1.GetCollision()->CheckCollision(baer.GetPos()+baer.GetUp()*3, 3.0f))					// den Drop mit Mindestwert austesten
						baer.MoveUp(-3*cos(PIdiv180*(100))*frameratefactor);
				dropvar = 5.0f;
			} else if (baer.GetPos().y < 0.0) {
				baer.MoveUp(-baer.GetPos().y);
				dropvar = 0.0f;
			} else {
				if (baer.GetAnimType()==JUMP)
					baer.SetAnim(STAND);
      			if (dropvar+10*frameratefactor<=90) dropvar+=10*frameratefactor;
			}
		} else dropvar = 0.0f;
		
		
	}
	//if (baer.GetPos().y < 0) {baer.MoveUp(-baer.GetPos().y);}
	//if(objectup) {
	//	paperplane.RotateX(-2.0f);
	//	//cam.RotateX(-2.0f);
	//}
	//if(objectdown) {
	//	paperplane.RotateX(2.0f);
	//	//cam.RotateX(2.0);
	//}
	
	if (ziel.CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
		ziel.CheckCollision (baer.GetPos()+baer.GetUp()*3, 3.0f)){
			ziel.Translate(1000,1000,1000);
			starr.ScaleModel(0.0);
			MessageBoxA(0,"WOHOW YE GOT TAH STAR!", "Game (kind of) Ended!",MB_ICONINFORMATION);
	}

	if (keyy.CheckCollision(baer.GetPos()+baer.GetUp()*5, 3.0f) ||
		keyy.CheckCollision (baer.GetPos()+baer.GetUp()*3, 3.0f)) {
			keyy.Translate(1000,1000,1000);
			key.ScaleModel(0.0);
			doorvisible=false;
			level1.GetCollision()->GetCube(doornumber)->Translate(1000,1000,1000);
	}

	if (!freecam)
	//cam.SetCam(baer.GetPos()-baer.GetView()*40+baer.GetUp()*10, baer.GetView(), baer.GetUp(), baer.GetRight());
	//cam.SetCam(baer.GetPos()-cam.GetView()*40, cam.GetView(), baer.GetRight().CrossProduct(cam.GetView()), baer.GetRight());
	cam.SetCam(baer.GetPos()+baer.GetUp()*8-cam.GetView()*40, cam.GetView(), baer.GetRight().CrossProduct(cam.GetView()), baer.GetRight());
	/*if (counter%10==0) {

	}
	counter++;*/

	//cam.SetCam(paperplane.GetPos()-paperplane.GetView()*20+paperplane.GetUp()*5, paperplane.GetView(), paperplane.GetUp(), paperplane.GetRight());

	//cam.MoveFwd((paperplane.GetPos()-cam.GetPos()/*-paperplane.GetView()*20-paperplane.GetUp()*-5*/).z);
	//std::cout << "paper: " << paperplane.GetPos().x << " " << paperplane.GetPos().y << " " << paperplane.GetPos().z << endl;
	//std::cout << "cam: " << cam.GetPos().x << " " << cam.GetPos().y << " " << cam.GetPos().z << endl;
	//cam.MoveRight((paperplane.GetPos()-cam.GetPos()/*-paperplane.GetView()*20-paperplane.GetUp()*-5*/).x);
	//cam.MoveUp((paperplane.GetPos()-cam.GetPos()/*-paperplane.GetView()*20-paperplane.GetUp()*-5*/).y);
}


float rotx = 0.01f, roty=0.0f;

int rotStar = 0;
int ogrosLife = 3;
int lastAttack = -1;
bool ogrosDead = false;
int deathtime = -1;

void Render() {
	oldtime = time;
	//glFinish();
	QueryPerformanceCounter(&time);
	float seconds_passed = (float)(time.QuadPart-oldtime.QuadPart)/(float)frequency.QuadPart;
	framerate = 1/seconds_passed;
	/*if (lasttimestamp != 0) framerate = (double)1000.0f/(double)(GetTickCount() - lasttimestamp);
	lasttimestamp = GetTickCount();*/
	//if (framerate < (double)10000.0f) printf("fps: %lf\n", framerate);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	float global_ambient[] = { 0.2f, 0.2f, 0.2f, 1.0f };
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);

/// ----- Light Grass -----
	//float lightcolour[] = {0.5f, 0.5f, 0.5f, 1.0f};
	//float lightcolourAmbient[] = {0.0f, 0.0f, 0.0f, 1.0f};
	//float lightPosition[] = {3.0f, 3.0f, 0.0f, 1.0f};
	//glLightfv(GL_LIGHT0, GL_AMBIENT, lightcolourAmbient);
	//glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcolour);
	//glLightfv(GL_LIGHT0, GL_SPECULAR, lightcolourAmbient);
	//glLightfv(GL_LIGHT0, GL_POSITION, lightPosition);
/// ----- Light Grass -----

/// ----- Light Moon -----
	float lightcolour2[] = {0.8f, 0.85f, 1.0f, 1.0f};
	float lightcolourAmbient2[] = {0.0f, 0.0f, 0.0f, 1.0f};
	float lightcolourSpecular2[] = {0.8f, 0.8f, 0.8f, 1.0f};
	float lightPosition2[] = {200.0f, 120.0f, -160.0f, 1.0f};
	//float lightPosition2[] = {200.0f+baer.GetPos().x, 120.0f+baer.GetPos().y, -160.0f+baer.GetPos().z, 1.0f};
	float lightDirection2[] = {-1.0f, -0.6f, 0.8f};
	glLightfv(GL_LIGHT1, GL_AMBIENT, lightcolourAmbient2);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, lightcolour2);
	glLightfv(GL_LIGHT1, GL_SPECULAR, lightcolourSpecular2);
	glLightfv(GL_LIGHT1, GL_POSITION, lightPosition2);
	glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, lightDirection2);
/// ----- Light Moon -----

/// ----- Render Camera -----
	cam.Render();
/// ----- Render Camera

/// ----- Sky Box -----
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glPushMatrix();
	glBindTexture(GL_TEXTURE_2D, texture[4]);
	star.SetModel(Vector( cam.GetPos().x, cam.GetPos().y, cam.GetPos().z ), Vector(1.0f, 0.0f, 0.0f), Vector(0.0f, 1.0f, 0.0f), Vector(0.0f, 0.0f, 1.0f));
	star.DrawFrame(0,false,false);
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
	
	//glEnable(GL_LIGHTING);
/// ----- Sky Box -----

	glPushMatrix();
	glLoadIdentity();
	glColor3f(1.0f,1.0f,1.0f);
	glRasterPos3f(-0.6f,0.4f,-1.0f);
	if(showframerate)
		glPrint("Torn'n'Sewn 2.3d Copyright 2008 --- FPS: %f ", framerate);
	if(wireframe && wireframetimer>0)
		glPrint("Wireframe ein ");
	if(frustum && frustumtimer>0)
		glPrint("Frustum Culling ein ");
	if(!wireframe && wireframetimer>0)
		glPrint("Wireframe aus ");
	if(!frustum && frustumtimer>0)
		glPrint("Frustum Culling aus ");
	glPopMatrix();
	
	if (wireframetimer>0)
		wireframetimer--;
	if (frustumtimer>0)
		frustumtimer--;

///// ----- Coordinate System -----
//	/*glPushMatrix();
//	glBegin(GL_LINES);
//		glColor3f(1.0f,0.0f,0.0f);
//		glVertex3f(baer.GetPos().x, baer.GetPos().y+4, baer.GetPos().z);
//		glVertex3f(baer.GetPos().x+baer.GetRight().x*10, baer.GetPos().y+baer.GetRight().y*10+4, baer.GetPos().z+baer.GetRight().z*10);
//		glColor3f(0.0f,0.0f,1.0f);
//		glVertex3f(baer.GetPos().x, baer.GetPos().y+4, baer.GetPos().z);
//		glVertex3f(baer.GetPos().x+baer.GetUp().x*10, baer.GetPos().y+baer.GetUp().y*10+4, baer.GetPos().z+baer.GetUp().z*10);
//		glColor3f(0.0f,1.0f,0.0f);
//		glVertex3f(baer.GetPos().x, baer.GetPos().y+4, baer.GetPos().z);
//		glVertex3f(baer.GetPos().x+baer.GetView().x*10, baer.GetPos().y+baer.GetView().y*10+4, baer.GetPos().z+baer.GetView().z*10);
//	glEnd();
//	glPopMatrix();*/
///// ----- Coordinate System -----
//
///// ------ Draw Star -----
//	//glShadeModel(GL_FLAT);
//	glPushMatrix();
//	/*rotStar+=5;
//	if (rotStar==360) rotStar = 0;
//	glTranslatef(-27.5f, 36.0f, -7.5f);
//	glRotatef(rotStar,0.0f,1.0f,0.0f);*/
//
//	star.SetModel(Vector(-27.5f, 41.0f, -7.5f), star.GetView(), star.GetUp(), star.GetRight());
//	star.RotateY(3);
//
//	glBindTexture(GL_TEXTURE_2D, texture[3]);
//	star.DrawMD2(0);
//	glPopMatrix();
//	if(coordinates) star.DrawCoord();
//	//glShadeModel(GL_SMOOTH);
///// ----- Draw Star -----
//
///// ----- Draw Grass -----
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[5]);
//	//grass.SetModel(Vector(100.0f, 0.0f, -10.0f), grass.GetView(), grass.GetUp(), grass.GetRight());
//	grass.DrawMD2(0);
//	glPopMatrix();
//	if(coordinates) grass.DrawCoord();
///// ----- Draw Grass -----

///// ----- Draw Pig -----
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[6]);
//	//glRotatef(45.0f, 0.0f, 1.0f, 0.0f);
//	pig.SetModel(Vector(70.0f, 7.0f, -200.0f), pig.GetView(), pig.GetUp(), pig.GetRight());
//	//glScalef(0.2f,0.2f,0.2f);
//	pig.DrawMD2(0);
//	glPopMatrix();
//	if(coordinates) pig.DrawCoord();
///// ----- Draw Pig -----
//
///// ----- Draw Room -----
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[7]);
//	//glScalef(5.0f,5.0f,5.0f);
//	//glRotatef(45.0f, 0.0f, 1.0f, 0.0f);
//	room.SetModel(Vector(30.0f, -0.4f, -20.0f), room.GetView(), room.GetUp(), room.GetRight());
//	room.DrawMD2(0);
//	glPopMatrix();
//	if(coordinates) room.DrawCoord();
///// ----- Draw Room -----

	float frameratefactor = OPT_FRAMERATE/framerate;

	float timer = (float)GetTickCount()/1000.0f;

	level1.DrawScene(timer, wireframe, frustum);

/// ----- Draw Bear -----
	baer.DrawMD2(timer, wireframe);
	if(coordinates) baer.DrawCoord();
/// ----- Draw Bear -----
	
	CollisionBubble ogrosBubble = CollisionBubble(ogros.GetPos(), 5);

	int twist = (rand()%21)-10;
	int walk = (rand()%5);

	
	//ogros.RotateY(twist*frameratefactor);
	//rotStar+=frameratefactor;
	rotStar ++;



	if (ogrosLife > 0) {

		/*if (rotStar > 10) {*/
			ogros.MoveFwd(0.6*frameratefactor);
		/*}*/
	//ogros.MoveFwd((float)walk/5*frameratefactor);

	if (level1.GetCollision()->CheckCollision(ogros.GetPos()+ogros.GetUp()*5, 10.0f))
		ogros.RotateY(12*frameratefactor);
	//	ogros.MoveFwd(-walk*frameratefactor);
	

	if (lastAttack == rotStar%20) {
		lastAttack = -1;
		ogros.SetAnim(RUN);
	}

	if (ogrosBubble.CheckCollision(baer.GetPos(), 5.0f)) {
		if (objectattack && (ogros.GetPos()-baer.GetPos()).DotProduct(baer.GetView()) > 0.0f && lastAttack == -1) {
			ogros.SetAnim(BEHIT);
			ogrosLife--;
			lastAttack = rotStar%20;
		}
	}

	}

	if (ogrosLife == 0 && deathtime == rotStar%10) {
		ogrosDead = true;
		deathtime = -1;
	}

	if (ogrosLife == 0 && !ogrosDead) {
		if (ogros.GetAnimType()!=DIE) {
			ogros.SetAnim(DIE);
			deathtime=rotStar%10;
		}
	}

	if (ogrosDead) {
		ogros.DrawFrame(67,wireframe, true);
	}else
		ogros.DrawMD2(timer, wireframe);
	

	if (rotStar==360) rotStar = 0;

	key.RotateY(0);
	starr.RotateY(0);
	
	key.DrawMD2(timer,wireframe);
	starr.DrawMD2(timer, wireframe);

	if (doorvisible)
		door.DrawFrame(0, wireframe);






	//if (ogrosBubble.CheckCollision(baer.GetPos(), 50.0f)) {
		//Vector orient = Vector(baer.GetPos()-ogros.GetPos());
		//Vector view = Vector(ogros.GetView());
		//orient.x /= sqrt(pow(orient.x,2)+ pow(orient.z,2));
		//orient.z /= sqrt(pow(orient.x,2)+ pow(orient.z,2));
		//view.x /= sqrt(pow(view.x,2)+ pow(view.z,2));
		//view.z /= sqrt(pow(view.x,2)+ pow(view.z,2));
		//float dot = view.x*orient.x+view.z*orient.z;
		//printf("%f \n", acos(dot)*180/PI);
		////if (orient.CrossProduct(view).z > 0)
		////if (dot <= 0.01 && dot >=-0.01) {
		////	dot = 0;
		////}
		//if (acos(dot)*180/PI == acos(dot)*180/PI)
		//	ogros.RotateY((float)acos(-dot)*180/PI);
		////else
		//	
		//if (!ogrosBubble.CheckCollision(baer.GetPos(), 10.0f)) {
		//	ogros.MoveFwd(0.5*frameratefactor);
		//}
	//}
	//else
	//{
	//	ogros.RotateY(2.0f*frameratefactor);
	//}
	//ogros.MoveFwd(0.5*frameratefactor);


//	//ogros.DrawMD2(timer);
//	ogros.DrawFrame(0);
//	weapon.DrawMD2(timer);
//
//	flower.ScaleModel(0.5f);
//	flower.SetModel(Vector(0.0f, 70.0f, 0.0f), flower.GetView(), flower.GetUp(), flower.GetRight());
//	//flower.RotateY(3.0f);
//	flower.DrawMD2(timer);
//
//	tower.DrawFrame(0);
//
///// ----- Draw Floor ----
//	glBindTexture(GL_TEXTURE_2D, texture[1]);
//	glBegin(GL_QUADS);
//		glNormal3f( 0.0f, 1.0f, 0.0f);
//		glTexCoord2f( 0.0f,  0.0f); glVertex3f(-160.0f, 0.0f,  -160.0f);	// Bottom Left Of The Texture and Quad
//		glTexCoord2f(2.0f,  0.0f); glVertex3f( 160.0f, 0.0f,  -160.0f);	// Bottom Right Of The Texture and Quad
//		glTexCoord2f(2.0f, 2.0f); glVertex3f( 160.0f, 0.0f,  160.0f);	// Top Right Of The Texture and Quad
//		glTexCoord2f( 0.0f, 2.0f); glVertex3f(-160.0f, 0.0f,  160.0f);	// Top Left Of The Texture and Quad
//	glEnd();
///// ----- Draw Floor -----
//
///// ----- Draw Crates -----
//	glBindTexture(GL_TEXTURE_2D, texture[2]);
//
//	glBegin(GL_QUADS);
//		glNormal3f(-2.0f/sqrt(13.0f), 0.0f,-3.0f/sqrt(13.0f));
//		glTexCoord2f(1/6.0f, 1.0f); glVertex3f(-40.0f, 0.0f, -50.0f);	
//		glTexCoord2f(1/6.0f, 0.0f); glVertex3f(-40.0f,  18.0f, -50.0f);	// Top Right O
//		glTexCoord2f(0.0f, 0.0f); glVertex3f( -25.0f, 18.0f, -60.0f);	// Top Leftad
//		glTexCoord2f(0.0f, 1.0f); glVertex3f( -25.0f, 0.0f, -60.0f);	// Bottom Left O
//		// Top Face
//		glNormal3f( 3.0f/sqrt(13.0f), 0.0f,-2.0f/sqrt(13.0f));
//		glTexCoord2f(1/6.0f, 1.0f); glVertex3f(-25.0f,  0.0f, -60.0f);	// Top L
//		glTexCoord2f(1/6.0f, 0.0f); glVertex3f(-25.0f, 18.0f, -60.0f);	// Bott
//		glTexCoord2f(1/3.0f, 0.0f); glVertex3f(-15.0f, 18.0f, -45.0f);	// Bottom Rture and Quad
//		glTexCoord2f(1/3.0f, 1.0f); glVertex3f(-15.0f, 0.0f, -45.0f);
//		// Bottom Face
//		glNormal3f( 2.0f/sqrt(13.0f), 0.0f, 3.0f/sqrt(13.0f));
//		glTexCoord2f(1/3.0f, 1.0f); glVertex3f(-15.0f, 0.0f, -45.0f);
//		glTexCoord2f(1/3.0f, 0.0f); glVertex3f(-15.0f, 18.0f, -45.0f);	// 
//		glTexCoord2f(1/2.0f, 0.0f); glVertex3f(-30.0f, 18.0f, -35.0f);	// Bottom Left nd Quad
//		glTexCoord2f(1/2.0f, 1.0f); glVertex3f(-30.0f, 0.0f,  -35.0f);	// BoQuad
//		// Right face
//		glNormal3f(-3.0f/sqrt(13.0f), 0.0f, 2.0f/sqrt(13.0f));
//		glTexCoord2f(1/2.0f, 1.0f); glVertex3f( -30.0f, 0.0f, -35.0f);
//		glTexCoord2f(1/2.0f, 0.0f); glVertex3f( -30.0f, 18.0f,-35.0f);
//		glTexCoord2f(2/3.0f, 0.0f); glVertex3f( -40.0f,  18.0f, -50.0f);
//		glTexCoord2f(2/3.0f, 1.0f); glVertex3f( -40.0f, 0.0f, -50.0f);
//		// Left Face
//		glNormal3f( 0.0f, 1.0f, 0.0f);
//		glTexCoord2f(5/6.0f, 1.0f); glVertex3f(-40.0f, 18.0f, -50.0f);
//		glTexCoord2f(5/6.0f, 0.0f); glVertex3f(-30.0f, 18.0f, -35.0f);
//		glTexCoord2f(1.0f, 0.0f); glVertex3f(-15.0f,  18.0f, -45.0f);
//		glTexCoord2f(1.0f, 1.0f); glVertex3f(-25.0f,  18.0f, -60.0f);
//	glEnd();
//
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[2]);
//	glTranslatef( 50.0f, 15.0f, 0.0f );
//	//glRotatef( 45.0f, 0.0f, 1.0f, 0.0f );
//	glDrawCube( 20.0f, 30.0f, 35.0f );
//	glPopMatrix();
//
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[2]);
//	glTranslatef( 30.0f, 9.0f, 0.0f );
//	glDrawCube( 18.0f, 18.0f, 18.0f );
//	glPopMatrix();
//
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[2]);
//	glTranslatef( 10.0f, 27.0f, 0.0f );
//	glDrawCube( 18.0f, 18.0f, 18.0f );
//	glPopMatrix();
//
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[2]);
//	glTranslatef(-30.0f, 45.0f, 20.0f );
//	glDrawCube( 18.0f, 18.0f, 18.0f );
//	glPopMatrix();
//
//	glPushMatrix();
//	glBindTexture(GL_TEXTURE_2D, texture[5]);
//	glTranslatef(-20.0f,-20.0f,-20.0f);
//	glutSolidSphere(25.0, 20, 20);
//	glPopMatrix();
//
//	glBindTexture(GL_TEXTURE_2D, texture[2]);
//
//	glBegin(GL_QUADS);
//		glNormal3f(-2.0f/sqrt(13.0f), 0.0f,-3.0f/sqrt(13.0f));
//		glTexCoord2f(1/6.0f, 1.0f); glVertex3f(-40.0f, 18.0f, -10.0f);	
//		glTexCoord2f(1/6.0f, 0.0f); glVertex3f(-40.0f,  36.0f, -10.0f);	// Top Right O
//		glTexCoord2f(0.0f, 0.0f); glVertex3f( -25.0f, 36.0f, -20.0f);	// Top Leftad
//		glTexCoord2f(0.0f, 1.0f); glVertex3f( -25.0f, 18.0f, -20.0f);	// Bottom Left O
//		// Top Face
//		glNormal3f(3.0f/sqrt(13.0f), 0.0f,-2.0f/sqrt(13.0f));
//		glTexCoord2f(1/6.0f, 1.0f); glVertex3f(-25.0f,  18.0f, -20.0f);	// Top L
//		glTexCoord2f(1/6.0f, 0.0f); glVertex3f(-25.0f, 36.0f, -20.0f);	// Bott
//		glTexCoord2f(1/3.0f, 0.0f); glVertex3f(-15.0f, 36.0f, -5.0f);	// Bottom Rture and Quad
//		glTexCoord2f(1/3.0f, 1.0f); glVertex3f(-15.0f, 18.0f, -5.0f);
//		// Bottom Face
//		glNormal3f( 2.0f/sqrt(13.0f), 0.0f, 3.0f/sqrt(13.0f));
//		glTexCoord2f(1/3.0f, 1.0f); glVertex3f(-15.0f, 18.0f, -5.0f);
//		glTexCoord2f(1/3.0f, 0.0f); glVertex3f(-15.0f, 36.0f, -5.0f);	// 
//		glTexCoord2f(1/2.0f, 0.0f); glVertex3f(-30.0f, 36.0f, 5.0f);	// Bottom Left nd Quad
//		glTexCoord2f(1/2.0f, 1.0f); glVertex3f(-30.0f, 18.0f,  5.0f);	// BoQuad
//		// Right face
//		glNormal3f(-3.0f/sqrt(13.0f), 0.0f, 2.0f/sqrt(13.0f));
//		glTexCoord2f(1/2.0f, 1.0f); glVertex3f( -30.0f, 18.0f, 5.0f);
//		glTexCoord2f(1/2.0f, 0.0f); glVertex3f( -30.0f, 36.0f,5.0f);
//		glTexCoord2f(2/3.0f, 0.0f); glVertex3f( -40.0f,  36.0f, -10.0f);
//		glTexCoord2f(2/3.0f, 1.0f); glVertex3f( -40.0f, 18.0f, -10.0f);
//		// Left Face
//		glNormal3f(0.0f, 1.0f, 0.0f);
//		glTexCoord2f(2/3.0f, 1.0f); glVertex3f(-40.0f, 36.0f, -10.0f);
//		glTexCoord2f(2/3.0f, 0.0f); glVertex3f(-30.0f, 36.0f, 5.0f);
//		glTexCoord2f(5/6.0f, 0.0f); glVertex3f(-15.0f,  36.0f, -5.0f);
//		glTexCoord2f(5/6.0f, 1.0f); glVertex3f(-25.0f,  36.0f, -20.0f);
//		// Left Face
//		glNormal3f( 0.0f,-1.0f, 0.0f);
//		glTexCoord2f(5/6.0f, 1.0f); glVertex3f(-40.0f, 18.0f, -10.0f);
//		glTexCoord2f(5/6.0f, 0.0f); glVertex3f(-30.0f, 18.0f, 5.0f);
//		glTexCoord2f(1.0f, 0.0f); glVertex3f(-15.0f,  18.0f, -5.0f);
//		glTexCoord2f(1.0f, 1.0f); glVertex3f(-25.0f,  18.0f, -20.0f);
//	glEnd();
///// ------ Draw Crates ------

	glutSwapBuffers();
}

GLvoid glDrawCube(float x,float y, float z)					// Draw A Cube
{
		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE); 
		
		glBegin(GL_QUADS);			// Start Drawing Quads

		// Front Face
		glNormal3f( 0.0f, 0.0f, 1.0f);		// Normal Facing Forward
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-x/2.0f, -y/2.0f,  z/2.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -x/2.0f, y/2.0f,  z/2.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1/6.0f, 1.0f); glVertex3f( x/2.0f,  y/2.0f,  z/2.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(1/6.0f, 0.0f); glVertex3f(x/2.0f,  -y/2.0f,  z/2.0f);	// Top Left Of The Texture and Quad
		// Right face
		glNormal3f(-1.0f, 0.0f, 0.0f);		// Normal Facing Right
		glTexCoord2f(1/2.0f, 0.0f); glVertex3f(-x/2.0f, -y/2.0f, -z/2.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1/2.0f, 1.0f); glVertex3f(-x/2.0f, y/2.0f,  -z/2.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(2/3.0f, 1.0f); glVertex3f(-x/2.0f, y/2.0f,   z/2.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(2/3.0f, 0.0f); glVertex3f(-x/2.0f, -y/2.0f,  z/2.0f);	// Top Left Of The Texture and Quad
		// Back Face
		glNormal3f( 0.0f, 0.0f,-1.0f);		// Normal Facing Away
		glTexCoord2f(1/3.0f, 0.0f); glVertex3f(x/2.0f, -y/2.0f, -z/2.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1/3.0f, 1.0f); glVertex3f(x/2.0f,  y/2.0f, -z/2.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(1/2.0f, 1.0f); glVertex3f(-x/2.0f,  y/2.0f, -z/2.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(1/2.0f, 0.0f); glVertex3f(-x/2.0f, -y/2.0f, -z/2.0f);	// Bottom Left Of The Texture and Quad
		// Left Face
		glNormal3f(1.0f, 0.0f, 0.0f);		// Normal Facing Left
		glTexCoord2f(1/6.0f, 0.0f); glVertex3f( x/2.0f, -y/2.0f, z/2.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1/6.0f, 1.0f); glVertex3f( x/2.0f,  y/2.0f, z/2.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(1/3.0f, 1.0f); glVertex3f( x/2.0f,  y/2.0f, -z/2.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(1/3.0f, 0.0f); glVertex3f( x/2.0f, -y/2.0f, -z/2.0f);	// Bottom Left Of The Texture and Quad
		// Top Face
		glNormal3f( 0.0f,1.0f, 0.0f);
		glTexCoord2f(5/6.0f, 1.0f); glVertex3f(-x/2.0f,  y/2.0f, z/2.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(5/6.0f, 0.0f); glVertex3f( x/2.0f,  y/2.0f,  z/2.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(2/3.0f, 0.0f); glVertex3f( x/2.0f,  y/2.0f,  -z/2.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(2/3.0f, 1.0f); glVertex3f( -x/2.0f,  y/2.0f, -z/2.0f);	// Top Right Of The Texture and Quad
		// Bottom Face
		glNormal3f( 0.0f,-1.0f, 0.0f);		// Normal Facing Down
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-x/2.0f, -y/2.0f, z/2.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( x/2.0f, -y/2.0f, z/2.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(5/6.0f, 0.0f); glVertex3f( x/2.0f, -y/2.0f, -z/2.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(5/6.0f, 1.0f); glVertex3f(-x/2.0f, -y/2.0f, -z/2.0f);	// Bottom Right Of The Texture and Quad
	glEnd();					// Done Drawing Quads
}


void ResizeScene(int width, int height) {
	if (height == 0) height = 1;
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective((GLdouble) 45.0f, (GLdouble) WIN_WIDTH/WIN_HEIGHT, (GLdouble) 0.1f, (GLdouble) 100.0f);

	glMatrixMode(GL_MODELVIEW);
}