#include <windows.h>
#include "Level.h"
#include "camera.h"
#include "vector.h"
#include "global.h"
#include <cmath>
#include <stdarg.h>		// Header File For Variable Argument Routines
#include "Bitmap.h"
#include <GL/glut.h>

#define WIN_X 50
#define WIN_Y 100
#define WIN_BITDEPTH 24
#define MAXMODELCOUNT 100
#define TNS_REFRESHRATE 25
#define TNS_WINDOWTITLE "TNS Window"
#define OPT_FRAMERATE 30

void InitGL();
int InitScene();
GLvoid glDrawCube(float x,float y, float z);
void UnloadScene();
void Update();
void Render();
void CamMovement(GLint xMouse, GLint yMouse);
void MouseClickFunc(int, int, int, int);
void KeyboardHandler(unsigned char key, int x, int y);
void KeyboardUpHandler(unsigned char key, int x, int y);
void KeyboardSpecialHandler(int key,int x,int y);
int CreateTNSWindow(bool fullscreen, int width, int height, int x, int y, int bits, char* title);
int win = 0;
void ShowError(char* text, bool destroy);
void ResizeScene(int width, int height);
void DestroyTNSWindow();
void _Timer(int value);
GLvoid BuildFont(GLvoid);
GLvoid glPrint(const char *fmt, ...);
LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

typedef GLint vertex3 [3];
int modelcount = 0;
int lastmousex = 0;
int lastmousey = 0;
float camhorizontalangle = 30;
float framerate = 0.0f;
DWORD lasttimestamp;
LARGE_INTEGER frequency; // das ist ein Datentyp fr 64-bit integer
LARGE_INTEGER time, oldtime;
Camera cam;

HINSTANCE hInstance;
HWND hWindow;

Model baer;
Model star;
Model grass;
Model pig;
Model room, ogros, weapon, flower, tower, door, key, starr;

Level level1;

GLuint texture[60];

GLuint	base;			// Base Display List For The Font Set
HDC hDC=NULL; 			// Private GDI Device Context

CollisionCollection coll;
CollisionCreator creator;

bool objectforward = false, objectback = false, objectright = false, objectleft = false, objectup = false, 
	 objectdown = false, objectjump = false, objectdie = false, objecthit = false, objectattack = false;
bool cameraforward = false, cameraback = false, cameraright = false, cameraleft = false, cameraup = false, cameradown = false;
bool coordinates = false;
bool freecam = false;
bool wireframe = false;
bool showframerate = false;
bool texqual = false;
bool frustum = true;
int mipmap = 0;

int wireframetimer = 0, frustumtimer = 0;
