#include "vector.h"

void Vector::Normalise() {
	float length = GetLength();
	if (length != 0) {
		x /= length;
		y /= length;
		z /= length;
	}
}

Vector Vector::CrossProduct(Vector &op) {
	Vector result;
	result.x = y*op.z - z*op.y;
	result.y = z*op.x - x*op.z;
	result.z = x*op.y - y*op.x;
	return result;
}

float Vector::DotProduct(Vector &op) {
	return (x*op.x + y*op.y + z*op.z);
}